=== debian/changelog ===
kvmtool (0.20151104-1) sid; urgency=low

  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 03c49af
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/57/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: ce5757d

 -- Riku Voipio <riku.voipio@linaro.org>  Wed, 04 Nov 2015 10:45:40 +0000

kvmtool (0.20150908-1) sid; urgency=low

  * Initial release, closes: #797893
  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 0161ed7

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: f256101

 -- Riku Voipio <riku.voipio@linaro.org>  Tue, 08 Sep 2015 15:40:11 +0300
