=== debian/control ===
Source: kvmtool
Section: kernel
Priority: optional
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/kvmtool.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/kvmtool.git/
Homepage: https://git.kernel.org/cgit/linux/kernel/git/will/kvmtool.git/
Maintainer: Riku Voipio <riku.voipio@linaro.org>
Build-Depends: debhelper (>= 9), libc6-dev-i386 [amd64], libnewt-dev, libsdl1.2-dev[amd64 i386], libvncserver-dev[amd64 i386], libfdt-dev[armhf arm64 ppc64 ppc64el], binutils-dev, zlib1g-dev, libaio-dev, genisoimage

Package: kvmtool
Depends: ${misc:Depends}, ${shlibs:Depends}
Architecture: amd64 armhf arm64 i386 mips mipsel mips64el ppc64 ppc64el
Description: Native Linux KVM TOOL
 kvmtool is a lightweight tool for hosting KVM guests. As a pure virtualization
 tool it only supports guests using the same architecture, though it supports
 running 32-bit guests on those 64-bit architectures that allow this.
