=== debian/rules ===
#!/usr/bin/make -f
%:
	LDFLAGS="" dh $@ --parallel

override_dh_auto_install:
	install -d -m 755 debian/kvmtool/usr/bin
	install lkvm debian/kvmtool/usr/bin 

override_dh_auto_test:
	if [ -r /dev/kvm ]; then dh_auto_test; fi
