## kvmtool 0.20161128

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,9 @@
 include config/feature-tests.mak
 
 CC	:= $(CROSS_COMPILE)gcc
+CFLAGS	:=
 LD	:= $(CROSS_COMPILE)ld
+LDFLAGS	:=
 
 FIND	:= find
 CSCOPE	:= cscope
@@ -151,7 +153,8 @@
 
 # ARM
 OBJS_ARM_COMMON		:= arm/fdt.o arm/gic.o arm/ioport.o arm/irq.o \
-			   arm/kvm.o arm/kvm-cpu.o arm/pci.o arm/timer.o
+			   arm/kvm.o arm/kvm-cpu.o arm/pci.o arm/timer.o \
+			   arm/pmu.o
 HDRS_ARM_COMMON		:= arm/include
 ifeq ($(ARCH), arm)
 	DEFINES		+= -DCONFIG_ARM
@@ -160,7 +163,7 @@
 	OBJS		+= arm/aarch32/kvm-cpu.o
 	ARCH_INCLUDE	:= $(HDRS_ARM_COMMON)
 	ARCH_INCLUDE	+= -Iarm/aarch32/include
-	override CFLAGS	+= -march=armv7-a
+	CFLAGS		+= -march=armv7-a
 
 	ARCH_WANT_LIBFDT := y
 endif
@@ -272,16 +275,16 @@
 ifeq ($(LTO),1)
 	FLAGS_LTO := -flto
 	ifeq ($(call try-build,$(SOURCE_HELLO),$(CFLAGS),$(LDFLAGS) $(FLAGS_LTO)),y)
-		override CFLAGS	+= $(FLAGS_LTO)
+		CFLAGS		+= $(FLAGS_LTO)
 	endif
 endif
 
 ifeq ($(call try-build,$(SOURCE_STATIC),$(CFLAGS),$(LDFLAGS) -static),y)
-	override CFLAGS	+= -DCONFIG_GUEST_INIT
+	CFLAGS		+= -DCONFIG_GUEST_INIT
 	GUEST_INIT	:= guest/init
 	GUEST_OBJS	= guest/guest_init.o
 	ifeq ($(ARCH_PRE_INIT),)
-		GUEST_INIT_FLAGS	+= -static
+		GUEST_INIT_FLAGS	+= -static $(PIE_FLAGS)
 	else
 		CFLAGS			+= -DCONFIG_GUEST_PRE_INIT
 		GUEST_INIT_FLAGS	+= -DCONFIG_GUEST_PRE_INIT
@@ -289,7 +292,7 @@
 		GUEST_OBJS		+= guest/guest_pre_init.o
 	endif
 else
-	$(warning No static libc found. Skipping guest init)
+$(warning No static libc found. Skipping guest init)
 	NOTFOUND        += static-libc
 endif
 
@@ -304,6 +307,10 @@
 	endif
 endif
 
+ifeq ($(call try-build,$(SOURCE_HELLO),$(CFLAGS),-no-pie),y)
+	PIE_FLAGS	+= -no-pie
+endif
+
 ifneq ($(NOTFOUND),)
         $(warning Skipping optional libraries: $(NOTFOUND))
 endif
@@ -329,8 +336,7 @@
 DEFINES	+= -DBUILD_ARCH='"$(ARCH)"'
 
 KVM_INCLUDE := include
-override CFLAGS	+= $(CPPFLAGS) $(DEFINES) -I$(KVM_INCLUDE) -I$(ARCH_INCLUDE)
-override CFLAGS	+= -O2 -fno-strict-aliasing -g
+CFLAGS	+= $(CPPFLAGS) $(DEFINES) -I$(KVM_INCLUDE) -I$(ARCH_INCLUDE) -O2 -fno-strict-aliasing -g
 
 WARNINGS += -Wall
 WARNINGS += -Wformat=2
@@ -348,10 +354,10 @@
 WARNINGS += -Wwrite-strings
 WARNINGS += -Wno-format-nonliteral
 
-override CFLAGS	+= $(WARNINGS)
+CFLAGS	+= $(WARNINGS)
 
 ifneq ($(WERROR),0)
-	override CFLAGS += -Werror
+	CFLAGS += -Werror
 endif
 
 all: $(PROGRAM) $(PROGRAM_ALIAS) $(GUEST_INIT) $(GUEST_PRE_INIT)
@@ -368,6 +374,9 @@
 #
 STATIC_OBJS = $(patsubst %.o,%.static.o,$(OBJS) $(OBJS_STATOPT))
 
+STATIC_DEPS	:= $(foreach obj,$(STATIC_OBJS),\
+		$(subst $(comma),_,$(dir $(obj)).$(notdir $(obj)).d))
+
 $(PROGRAM)-static:  $(STATIC_OBJS) $(OTHEROBJS) $(GUEST_INIT) $(GUEST_PRE_INIT)
 	$(E) "  LINK    " $@
 	$(Q) $(CC) -static $(CFLAGS) $(STATIC_OBJS) $(OTHEROBJS) $(GUEST_OBJS) $(LDFLAGS) $(LIBS) $(LIBS_STATOPT) -o $@
@@ -383,20 +392,17 @@
 ifneq ($(ARCH_PRE_INIT),)
 $(GUEST_PRE_INIT): $(ARCH_PRE_INIT)
 	$(E) "  LINK    " $@
-	$(Q) $(CC) -s -nostdlib $(ARCH_PRE_INIT) -o $@
-	$(Q) $(LD) $(LDFLAGS) -r -b binary -o guest/guest_pre_init.o $(GUEST_PRE_INIT)
+	$(Q) $(CC) -s $(PIE_FLAGS) -nostdlib $(ARCH_PRE_INIT) -o $@
+	$(Q) $(LD) -r -b binary -o guest/guest_pre_init.o $(GUEST_PRE_INIT)
 endif
 
 $(GUEST_INIT): guest/init.c
 	$(E) "  LINK    " $@
 	$(Q) $(CC) $(GUEST_INIT_FLAGS) guest/init.c -o $@
-	$(Q) $(LD) $(LDFLAGS) -r -b binary -o guest/guest_init.o $(GUEST_INIT)
+	$(Q) $(LD) -r -b binary -o guest/guest_init.o $(GUEST_INIT)
 
 %.s: %.c
 	$(Q) $(CC) -o $@ -S $(CFLAGS) -fverbose-asm $<
-
-# The header file common-cmds.h is needed for compilation of builtin-help.c.
-builtin-help.static.o builtin-help.o: $(KVM_INCLUDE)/common-cmds.h
 
 $(OBJS):
 
@@ -425,12 +431,6 @@
 	$(Q) $(CC) -c $(c_flags) $(CFLAGS_DYNOPT) $< -o $@
 
 
-$(KVM_INCLUDE)/common-cmds.h: util/generate-cmdlist.sh command-list.txt
-
-$(KVM_INCLUDE)/common-cmds.h: $(wildcard Documentation/kvm-*.txt)
-	$(E) "  GEN     " $@
-	$(Q) util/generate-cmdlist.sh > $@+ && mv $@+ $@
-
 #
 # BIOS assembly weirdness
 #
@@ -439,6 +439,7 @@
 BIOS_CFLAGS += -mregparm=3
 
 BIOS_CFLAGS += -fno-stack-protector
+BIOS_CFLAGS += -fno-pic
 
 x86/bios.o: x86/bios/bios.bin x86/bios/bios-rom.h
 
@@ -456,3 +457,7 @@
 	$(E) "  LD      " $@
 	$(Q) $(LD) -T x86/bios/rom.ld.S -o x86/bios/bios.bin.elf x86/bios/memcpy.o x86/bios/entry.o x86/bios/e820.o x86/bios/int10.o x86/bios/int15.o
 
+x86/bios/bios.bin: x86/bios/bios.bin.elf
+	$(E) "  OBJCOPY " $@
+	$(Q) objcopy -O binary -j .text x86/bios/bios.bin.elf x86/bios/bios.bin
+
