=== debian/changelog ===
kvmtool (0.20161128-1) sid; urgency=medium

  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: b092242
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/91/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: c478d19

 -- Riku Voipio <riku.voipio@linaro.org>  Mon, 28 Nov 2016 14:36:37 +0000

kvmtool (0.20161024-1) sid; urgency=medium

  * Disable PIE for the bios blob, closes: 837561, 837545 
  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 0093df8
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/88/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: ab02560

 -- Riku Voipio <riku.voipio@linaro.org>  Mon, 24 Oct 2016 10:09:40 +0000

kvmtool (0.20160419-1) sid; urgency=low

  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: d62653e
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/81/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: ccef806

 -- Riku Voipio <riku.voipio@linaro.org>  Tue, 19 Apr 2016 18:42:02 +0000

kvmtool (0.20160314-1) sid; urgency=low

  * New upstream snapshot, closes: #817966, #817967
  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: f73b960
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/78/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: 84aabf9

 -- Riku Voipio <riku.voipio@linaro.org>  Mon, 14 Mar 2016 10:19:40 +0000

kvmtool (0.20160203-1) sid; urgency=low

  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 61bd297
    - build: https://ci.linaro.org/jenkins/job/build-kvmtool/75/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: fe53043

 -- Riku Voipio <riku.voipio@linaro.org>  Wed, 03 Feb 2016 21:38:38 +0000
