=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kvmtool
 Section: kernel
 Priority: optional
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Git: git://anonscm.debian.org/collab-maint/kvmtool.git
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/kvmtool.git/
 Homepage: https://git.kernel.org/cgit/linux/kernel/git/will/kvmtool.git/
