=== debian/changelog ===
kvmtool (0.20170904-1) sid; urgency=low

  * CI - kvmtool snapshot:
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 93dd128
    - build: https://ci.linaro.org/job/build-kvmtool/99/

    - debian/ repository: git://anonscm.debian.org/collab-maint/kvmtool.git
    - debian/ commit: efb9996

 -- Riku Voipio <riku.voipio@linaro.org>  Mon, 04 Sep 2017 06:31:06 +0000

kvmtool (0.20170609-1) sid; urgency=medium

  * New upstream snapshot, closes: #871486
  * Apply patch to fix libc-dev FTBFS, closes: #87333

 -- Riku Voipio <riku.voipio@linaro.org>  Wed, 30 Aug 2017 10:17:33 +0300
