=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: kernel
 Priority: optional
 Standards-Version: 3.9.8
-Vcs-Git: git://anonscm.debian.org/collab-maint/kvmtool.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/kvmtool.git/
+Vcs-Git: https://anonscm.debian.org/collab-maint/kvmtool.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/kvmtool.git
 Homepage: https://git.kernel.org/cgit/linux/kernel/git/will/kvmtool.git/
 Maintainer: Riku Voipio <riku.voipio@linaro.org>
 Build-Depends: debhelper (>= 9), libc6-dev-i386 [amd64], libnewt-dev, libsdl1.2-dev[amd64 i386], libvncserver-dev[amd64 i386], libfdt-dev[armhf arm64 ppc64 ppc64el], binutils-dev, zlib1g-dev, libaio-dev, genisoimage
