=== debian/rules ===
#!/usr/bin/make -f
%:
	V=1 dh $@ --parallel

override_dh_auto_install:
	install -d -m 755 debian/kvmtool/usr/bin
	install lkvm debian/kvmtool/usr/bin 

override_dh_auto_test:
	if [ -w /dev/kvm && -x /usr/bin/xorriso]; then dh_auto_test; fi
