=== debian/changelog ===
kvmtool (0.20251123-1) unstable; urgency=medium

  * Re-introduce - kvmtool snapshot (Closes: #1054321)
    - repository: git://git.kernel.org/pub/scm/linux/kernel/git/will/kvmtool.git
    - commit: 7ad32e5
    - debian/ repository: https://salsa.debian.org/ysk/kvmtool

 -- Yunseong Kim <ysk@kzalloc.com>  Sun, 23 Nov 2025 15:23:37 +0900

kvmtool (0.20170904-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group <packages@qa.debian.org>. (see: #1001570)

 -- Marcos Talau <talau@debian.org>  Tue, 15 Nov 2022 10:31:08 -0300

kvmtool (0.20170904-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs. (Closes: #897777)
    - Added upstream patches fixing this.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 05 Mar 2020 12:28:53 +0000
