=== debian/control ===
Source: kvmtool
Section: kernel
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: git@salsa.debian.org:ysk/kvmtool.git
Vcs-Browser: https://salsa.debian.org/ysk/kvmtool
Homepage: https://git.kernel.org/cgit/linux/kernel/git/will/kvmtool.git/
Maintainer: Yunseong Kim <ysk@kzalloc.com>
Build-Depends:
	debhelper-compat (= 13),
	libc6-dev-i386 [amd64],
	libsdl1.2-dev [amd64 i386] | libsdl2-dev [amd64 i386],
	libvncserver-dev[amd64 i386],
	libnewt-dev, libfdt-dev, binutils-dev, 
	zlib1g-dev, libaio-dev, xorriso
Rules-Requires-Root: no

Package: kvmtool
Depends: ${misc:Depends}, ${shlibs:Depends}
Architecture: linux-any
Description: Native Linux KVM TOOL
 kvmtool is a lightweight tool for hosting KVM guests. As a pure virtualization
 tool it only supports guests using the same architecture, though it supports
 running 32-bit guests on those 64-bit architectures that allow this.
